#include "CC1100/chipcon.h"



extern uint8_t CS;

void SPI_init(void)
{
	RCC->APB2RSTR|=1<<12;
	RCC->APB2ENR|=  RCC_APB2Periph_GPIOA;
	SPI1->CR1=0x5C;
	GPIOA->CRL&=0x000FFFFF;
	GPIOA->CRL|=0xB4B00000;
}

void cc_init(void)
{
	CC_clk_en;
/*#if(CS>=8)
     CC_PORT->CRH&=~((uint32_t)0xF<<((CS-8)*4));
     CC_PORT->CRH|=(0x3<<((CS-8)*4));               
#else*/
     CC_PORT->CRL&=~((uint32_t)0xF<<(CS*4));
     CC_PORT->CRL|=(0x3<<(CS*4));     
//#endif
#if(MOSI>=8)
     CC_PORT->CRH&=~((uint32_t)0xF<<((MOSI-8)*4));
     CC_PORT->CRH|=(0x3<<((MOSI-8)*4));               
#else
     CC_PORT->CRL&=~((uint32_t)0xF<<(MOSI*4));
     CC_PORT->CRL|=(0x3<<(MOSI*4));     
#endif
#if(SCK>=8)
     CC_PORT->CRH&=~((uint32_t)0xF<<((SCK-8)*4));
     CC_PORT->CRH|=(0x3<<((SCK-8)*4));               
#else
     CC_PORT->CRL&=~((uint32_t)0xF<<(SCK*4));
     CC_PORT->CRL|=(0x3<<(SCK*4));     
#endif
//	SPI_init();
	while(CC_PORT->IDR&1<<MISO);
	writeRFSettings();
	cc_strobe(TI_CCxxx0_SIDLE);
}


//#if TI_CC_RF_FREQ_433                          // 433 MHz
// Product = CC1100
// Crystal accuracy = 40 ppm
// X-tal frequency = 26 MHz
// RF output power = 0 dBm
// RX filterbandwidth = 540.000000 kHz
// Deviation = 0.000000
// Return state:  Return to RX state upon leaving either TX or RX
// Datarate = 250.000000 kbps
// Modulation = (7) MSK
// Manchester enable = (0) Manchester disabled
// RF Frequency = 433.000000 MHz
// Channel spacing = 199.951172 kHz
// Channel number = 0
// Optimization = Sensitivity
// Sync mode = (3) 30/32 sync word bits detected
// Format of RX/TX data = (0) Normal mode, use FIFOs for RX and TX
// CRC operation = (1) CRC calculation in TX and CRC check in RX enabled
// Forward Error Correction = (0) FEC disabled
// Length configuration = (1) Variable length packets, packet length configured by the first received byte after sync word.
// Packetlength = 255
// Preamble count = (2)  4 bytes
// Append status = 1
// Address check = (0) No address check
// FIFO autoflush = 0
// Device address = 0
// GDO0 signal selection = ( 6) Asserts when sync word has been sent / received, and de-asserts at the end of the packet
// GDO2 signal selection = (11) Serial Clock
void writeRFSettings(void)
{
    // Write register settings
    cc_write_reg(TI_CCxxx0_IOCFG2,   0x0B); // GDO2 output pin config.
    cc_write_reg(TI_CCxxx0_IOCFG0,   0x06); // GDO0 output pin config.
    cc_write_reg(TI_CCxxx0_PKTLEN,   0xFF); // Packet length.
    cc_write_reg(TI_CCxxx0_PKTCTRL1, 0x05); // Packet automation control.
    cc_write_reg(TI_CCxxx0_PKTCTRL0, 0x05); // Packet automation control.
    cc_write_reg(TI_CCxxx0_ADDR,     0x01); // Device address.
    cc_write_reg(TI_CCxxx0_CHANNR,   0x00); // Channel number.
    cc_write_reg(TI_CCxxx0_FSCTRL1,  0x0B); // Freq synthesizer control.
    cc_write_reg(TI_CCxxx0_FSCTRL0,  0x00); // Freq synthesizer control.
    cc_write_reg(TI_CCxxx0_FREQ2,    0x10); // Freq control word, high byte
    cc_write_reg(TI_CCxxx0_FREQ1,    0xA7); // Freq control word, mid byte.
    cc_write_reg(TI_CCxxx0_FREQ0,    0x62); // Freq control word, low byte.
    cc_write_reg(TI_CCxxx0_MDMCFG4,  0x2D); // Modem configuration.
    cc_write_reg(TI_CCxxx0_MDMCFG3,  0x3B); // Modem configuration.
    cc_write_reg(TI_CCxxx0_MDMCFG2,  0x73); // Modem configuration.
    cc_write_reg(TI_CCxxx0_MDMCFG1,  0x22); // Modem configuration.
    cc_write_reg(TI_CCxxx0_MDMCFG0,  0xF8); // Modem configuration.
    cc_write_reg(TI_CCxxx0_DEVIATN,  0x00); // Modem dev (when FSK mod en)
    cc_write_reg(TI_CCxxx0_MCSM1 ,   0x3F); //MainRadio Cntrl State Machine
    cc_write_reg(TI_CCxxx0_MCSM0 ,   0x18); //MainRadio Cntrl State Machine
    cc_write_reg(TI_CCxxx0_FOCCFG,   0x1D); // Freq Offset Compens. Config
    cc_write_reg(TI_CCxxx0_BSCFG,    0x1C); //  Bit synchronization config.
    cc_write_reg(TI_CCxxx0_AGCCTRL2, 0xC7); // AGC control.
    cc_write_reg(TI_CCxxx0_AGCCTRL1, 0x00); // AGC control.
    cc_write_reg(TI_CCxxx0_AGCCTRL0, 0xB2); // AGC control.
    cc_write_reg(TI_CCxxx0_FREND1,   0xB6); // Front end RX configuration.
    cc_write_reg(TI_CCxxx0_FREND0,   0x10); // Front end RX configuration.
    cc_write_reg(TI_CCxxx0_FSCAL3,   0xEA); // Frequency synthesizer cal.
    cc_write_reg(TI_CCxxx0_FSCAL2,   0x0A); // Frequency synthesizer cal.
    cc_write_reg(TI_CCxxx0_FSCAL1,   0x00); // Frequency synthesizer cal.
    cc_write_reg(TI_CCxxx0_FSCAL0,   0x11); // Frequency synthesizer cal.
    cc_write_reg(TI_CCxxx0_FSTEST,   0x59); // Frequency synthesizer cal.
    cc_write_reg(TI_CCxxx0_TEST2,    0x88); // Various test settings.
    cc_write_reg(TI_CCxxx0_TEST1,    0x31); // Various test settings.
    cc_write_reg(TI_CCxxx0_TEST0,    0x0B); // Various test settings.
}

// PATABLE (0 dBm output power)
extern char paTable[] = {0x51};
extern char paTableLen = 1;

//#endif 


//-----------------------------------------------------------------------------
//  void RFSendPacket(char *txBuffer, char size)
//
//  DESCRIPTION:
//  This function transmits a packet with length up to 63 bytes.  To use this
//  function, GD00 must be configured to be asserted when sync word is sent and
//  de-asserted at the end of the packet, which is accomplished by setting the
//  IOCFG0 register to 0x06, per the CCxxxx datasheet.  GDO0 goes high at
//  packet start and returns low when complete.  The function polls GDO0 to
//  ensure packet completion before returning.
//
//  ARGUMENTS:
//      char *txBuffer
//          Pointer to a buffer containing the data to be transmitted
//
//      char size
//          The size of the txBuffer
//-----------------------------------------------------------------------------
void RFSendPacket(uint8_t *txBuffer, uint8_t size)
{
	cc_write_burst_reg(TI_CCxxx0_TXFIFO, txBuffer, size); // Write TX data
	cc_strobe(TI_CCxxx0_STX);// 
	while (!(CC_PORT->IDR&GDO0<<1));// Wait GDO0 to go hi -> sync TX'ed
	while (CC_PORT->IDR&GDO0<<1);// Wait GDO0 to clear -> end of pkt
}


//ReceivePacket
//  RETURN VALUE:
//      char
//          0x80:  CRC OK
//          0x00:  CRC NOT OK (or no pkt was put in the RXFIFO due to filtering)
//-----------------------------------------------------------------------------
uint8_t RFReceivePacket(uint8_t *rxBuffer, uint8_t *length) 
{
	uint8_t status[2];
	uint8_t packetLength;
	
	cc_strobe(TI_CCxxx0_SRX);
	while (!(CC_PORT->IDR&1<<GDO0));// 1  
	while (CC_PORT->IDR&1<<GDO0);// 0  
	 
	// This status register is safe to read since it will not be updated after
	// the packet has been received (See the CC1100 and 2500 Errata Note)
	if ((cc_read_status(TI_CCxxx0_RXBYTES) & TI_CCxxx0_NUM_RXBYTES)) 
	{
		packetLength = cc_read_reg(TI_CCxxx0_RXFIFO);// Read length byte
		if (packetLength <= *length)// Read data from RX FIFO and store in rxBuffer 
		{
			cc_read_burst_reg(TI_CCxxx0_RXFIFO, rxBuffer, packetLength); 
			*length = packetLength;
        
			// Read the 2 appended status bytes (status[0] = RSSI, status[1] = LQI)
			cc_read_burst_reg(TI_CCxxx0_RXFIFO, status, 2); 
        
			// MSB of LQI is the CRC_OK bit
			return (status[TI_CCxxx0_LQI_RX] & TI_CCxxx0_CRC_OK);
		}	else 
		{
			*length = packetLength;
 			cc_strobe(TI_CCxxx0_SIDLE);
 			cc_strobe(TI_CCxxx0_SFRX);// Flush RX FIFO
			return 0;
        }
    }	else
	return FALSE;	
}

void SCK_pulse(void)
{
 cc_sbi(SCK);
 for(int i=0; i<5; i++);
 cc_cbi(SCK);
}

void CC1100_writeregA(uint8_t *addresses, uint8_t *registers, uint8_t count)
{
 int i,j;
 i=0;j=0;
 cc_cbi(MOSI);
 cc_cbi(SCK);
 cc_cbi(CS);
 for (i=0;i<count;i++)
  {
   cc_cbi(MOSI);
   SCK_pulse();
   for (j=6;j>=0;j--)
    {
     if (addresses[i]&1<<j) cc_sbi(MOSI); else cc_cbi(MOSI);
	 SCK_pulse();
	}
   cc_cbi(SCK);
   for (j=7;j>=0;j--)
    {
	 if (registers[i]&1<<j) cc_sbi(MOSI); else cc_cbi(MOSI);
	 SCK_pulse();
    }
   cc_cbi(SCK);
  }
 cc_sbi(CS);
 cc_cbi(MOSI); /*
	cc_cbi(CS);
	SPI1->DR=(uint16_t)addresses;
//	while(!(SPI1->SR&2));
	SPI1->DR=(uint16_t)registers;
//	while(!(SPI1->SR&2));
	cc_sbi(CS);	*/
}

void CC1100_readregA(uint8_t *addresses, uint8_t *registers, uint8_t count)
{
 int i,j;
 i=0;j=0;
 cc_cbi(MOSI);
 cc_cbi(SCK);
 cc_cbi(CS);
 for (i=0;i<count;i++)
  {
   cc_sbi(MOSI);
   SCK_pulse();
   for (j=6;j>=0;j--)
    {
	 if (addresses[i]&1<<j) cc_sbi(MOSI); else cc_cbi(MOSI);
	 SCK_pulse();
    }
   cc_cbi(SCK);
   for (j=7;j>=0;j--)
    {
	 if (CC_PORT->IDR&1<<MISO) sbi(registers[i],j); else cbi(registers[i],j);
	 SCK_pulse();
    }
   cc_cbi(SCK);
  }
 cc_sbi(CS);
 cc_cbi(MOSI);/*
	 cc_cbi(CS);
	 SPI1->DR=(uint16_t)addresses;
	 while(!(SPI1->SR&1));
	 *registers=SPI1->DR;
	 SPI1->DR=0;
	 cc_sbi(CS);*/
}

void cc_write_burst_reg(uint8_t start_address, uint8_t *registers, uint8_t count)
{
 int i = 0;
 uint8_t j = start_address+0x40;
 cc_cbi(MOSI);
 cc_cbi(SCK);
 cc_cbi(CS);
 SCK_pulse();
 for (i=6;i>=0;i--)
  {
   if (j&1<<i) cc_sbi(MOSI); else cc_cbi(MOSI);
   SCK_pulse();
  }
 cc_cbi(SCK);
 for (j=0;j<count;j++)
 {
  for (i=7;i>=0;i--)
   {
    if (registers[j]&1<<i) cc_sbi(MOSI); else cc_cbi(MOSI);
	SCK_pulse();
   } 
  cc_cbi(SCK);
 }
 cc_sbi(CS);
 cc_cbi(MOSI);
}

void cc_read_burst_reg(uint8_t start_address, uint8_t *registers, uint8_t count)
{
 int i = 0;
 uint8_t j = start_address+0x40;
 cc_cbi(MOSI);
 cc_cbi(SCK);
 cc_cbi(CS);
 cc_sbi(MOSI);
 SCK_pulse();
 for (i=6;i>=0;i--)
 {
  if (j&1<<i) cc_sbi(MOSI); else cc_cbi(MOSI);
  SCK_pulse();
 }
 cc_cbi(SCK);
 for (j=0;j<count;j++)
 {
  for (i=7;i>=0;i--)
   {
    if (CC_PORT->IDR&1<<MISO) sbi(registers[j], i); else cbi(registers[j], i);
	SCK_pulse();
   }
  cc_cbi(SCK);
 }
 cc_sbi(CS);
 cc_cbi(MOSI);
}

void cc_strobe(uint8_t strobe)
{
 int i = 0;
 cc_cbi(MOSI);
 cc_cbi(SCK);
 cc_cbi(CS);
 SCK_pulse();
 for (i=6;i>=0;i--)
  {
   if (strobe&1<<i) cc_sbi(MOSI); else cc_cbi(MOSI);
   SCK_pulse();
  }
 cc_cbi(CS);
 cc_cbi(MOSI);
 for(int i=0; i<5; i++);/*
	cc_cbi(CS);
	SPI1->DR=(uint16_t)strobe;
	while(!(SPI1->SR&2));
	cc_sbi(CS);*/
}

uint8_t cc_read_status(uint8_t address)
{
 uint8_t st = 0;
 cc_read_burst_reg(address, &st, 1);
 return st;
}

uint8_t cc_read_reg(uint8_t address)
{
 uint8_t rg = 0;
 CC1100_readregA(&address, &rg, 1);
 return rg;
} 

void cc_write_reg(uint8_t address, uint8_t reg)
{
 CC1100_writeregA(&address, &reg, 1);
}

